function ArrayToText(array)
	local str = ""
	for i = 1, 18, 1 do
		str = str .. tostring(array[i])
	end
	return str
end

function GetPaintingX(i)
	if i == 1 then
		return 110656
	elseif i == 2 then
		return 110528
	elseif i == 3 then
		return 110720
	elseif i == 4 then
		return 110656
	elseif i == 5 then
		return 109504
	elseif i == 6 then
		return 109696
	elseif i == 7 then
		return 109888
	elseif i == 8 then
		return 110080
	elseif i == 9 then
		return 111232
	elseif i == 10 then
		return 111424
	elseif i == 11 then
		return 111616
	elseif i == 12 then
		return 111808
	elseif i == 13 then
		return 109952
	elseif i == 14 then
		return 110144
	elseif i == 15 then
		return 111168
	elseif i == 16 then
		return 111360
	elseif i == 17 then
		return 110464
	elseif i == 18 then
		return 110848
	end
end
function GetPaintingY(i)
	if i == 1 then
		return 5056
	elseif i == 2 then
		return 5440
	elseif i == 3 then
		return 5440
	elseif i == 4 then
		return 4672
	elseif i == 5 then
		return 5440
	elseif i == 6 then
		return 5440
	elseif i == 7 then
		return 5440
	elseif i == 8 then
		return 5440
	elseif i == 9 then
		return 5440
	elseif i == 10 then
		return 5440
	elseif i == 11 then
		return 5440
	elseif i == 12 then
		return 5440
	elseif i == 13 then
		return 5056
	elseif i == 14 then
		return 5056
	elseif i == 15 then
		return 5056
	elseif i == 16 then
		return 5056
	elseif i == 17 then
		return 4672
	elseif i == 18 then
		return 4672
	end
end

function CalculateTreasureScore(skulls, crowns, geckos, scepters, crosses, chalices, rings, goldbars, coins)
	return skulls*25000+crowns*15000+geckos*10000+scepters*7500+crosses*5000+chalices*1500+rings*1500+goldbars*500+coins*100
end

function main(self)
	if self.State == 0 then
		-- Load achievements file or create a new one, 
		self.achievements_statuses = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
		self.achievements_input = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
		self.paintings = {}
		self.change = 1
		self.generated = 0
		self.saveorder = 0
		self.TimePenalty = {0}
		
		self.file = io.open("Custom/Raid on the Spanish Armada/achievements.txt", "r")
		if self.file == nil then -- save file does not exist
			self.file = io.open("Custom/Raid on the Spanish Armada/achievements.txt", "w")
			io.output(self.file)
			io.write(ArrayToText(self.achievements_statuses))
			io.close(self.file)
		else -- save file exists
			local textdump = self.file:read()
			for i = 1, 18, 1 do
				local textdump1 = textdump:sub(i,i)
				if string.len(textdump1) == 1 then
					self.achievements_statuses[i] = tonumber(textdump1)
					self.achievements_input[i] = tonumber(textdump1)
				else
					self.achievements_statuses[i] = 0
					self.achievements_input[i] = 0
				end
			end
			io.close(self.file)
		end
		
		
		CreateObject {x=3160, y=5340, z=9000, name="Detector", logic="CustomLogic", image="GAME_SOUNDICON", Speed = 5, Direction = self.ID}
		CreateObject {x=18644, y=4466, z=9000, name="Detector", logic="CustomLogic", image="GAME_SOUNDICON", Speed = 6, Direction = self.ID}
		CreateObject {x=19207, y=4467, z=9000, name="Detector", logic="CustomLogic", image="GAME_SOUNDICON", Speed = 7, Direction = self.ID}
		CreateObject {x=37792, y=4032, z=9000, name="Detector", logic="CustomLogic", image="GAME_SOUNDICON", Speed = 8, Direction = self.ID}
		CreateObject {x=43424, y=1600, z=9000, name="Detector", logic="CustomLogic", image="GAME_SOUNDICON", Speed = 9, Direction = self.ID}
		CreateObject {x=107449, y=4864, z=9000, name="Detector", logic="CustomLogic", image="GAME_SOUNDICON", Speed = 10, Direction = self.ID}
		CreateObject {x=92496, y=4370, z=9000, name="Detector", logic="CustomLogic", image="GAME_SOUNDICON", Speed = 11, Direction = self.ID}
		CreateObject {x=98208, y=4896, z=9000, name="Detector", logic="CustomLogic", image="GAME_SOUNDICON", Speed = 12, Direction = self.ID}
		
		self.playerDied = 0
		self.playerGotHit = 0
		self.playerKill = 0
		self.bossStager = GetObject(6343)
		self.noDeath = 0
		self.Flag1 = 0
		self.Flag2 = 0
		self.CaptainKills = 0
		
		self.maxTreasurePoints = CalculateTreasureScore(GetTreasuresNb(TreasureType.Skull),GetTreasuresNb(TreasureType.Crown),
		GetTreasuresNb(TreasureType.Gecko),GetTreasuresNb(TreasureType.Scepter),GetTreasuresNb(TreasureType.Cross),
		GetTreasuresNb(TreasureType.Chalice),GetTreasuresNb(TreasureType.Ring),GetTreasuresNb(TreasureType.Goldbar),GetTreasuresNb(TreasureType.Coin))
		
		self.State = 1
	else
		if tonumber(self.achievements_input[1])>tonumber(self.achievements_statuses[1]) then
			self.achievements_statuses[1] = 1
			self.change = 1
			TextOut("Achievement unlocked")
			self.saveorder = 1
			
		end
		if ffi.cast("int*", _nResult[0][18])[74] == 0 then
			for i = 2, 18, 1 do
				if tonumber(self.achievements_input[i])>tonumber(self.achievements_statuses[i]) then
					self.achievements_statuses[i] = 1
					self.change = 1
					TextOut("Achievement unlocked")
					self.saveorder = 1
					
				end
			end
		end
		if self.saveorder == 1 then
			self.file = io.open("Custom/Raid on the Spanish Armada/achievements.txt", "w")
			io.output(self.file)
			io.write(ArrayToText(self.achievements_statuses))
			io.close(self.file)
			self.saveorder = 0
		end
	end
	if GetClaw().X > 109000 then
		if self.change == 1 then
			self.change = 0
			if self.generated == 0 then
				self.generated = 1 -- guess that was it
				
				for i = 1, 18, 1 do
					if self.achievements_statuses[i] == 1 then
						self.paintings[i] = CreateObject {x=GetPaintingX(i), y=GetPaintingY(i), z=-5, name="AchievementPicture", logic="CustomLogic", image="CUSTOM_ACHIEVEMENTSPAINTINGS", Speed = i}
						self.paintings[i].I = i
						self.paintings[i]:SetFrame(self.paintings[i].I)
					else
						self.paintings[i] = CreateObject {x=GetPaintingX(i), y=GetPaintingY(i), z=-5, name="AchievementPicture", logic="CustomLogic", image="CUSTOM_ACHIEVEMENTSPAINTINGSBLANK", Speed = i}
						--TextOut(i)
					end
				end
			else
				for i = 1, 18, 1 do
					if self.achievements_statuses[i] == 1 then
						self.paintings[i]:SetImage("CUSTOM_ACHIEVEMENTSPAINTINGS")
						self.paintings[i].I = i
						self.paintings[i]:SetFrame(self.paintings[i].I)
					else
						self.paintings[i]:SetImage("CUSTOM_ACHIEVEMENTSPAINTINGSBLANK")
					end
				end
			end
		end
	end
	if GetClaw().State == 5004 or GetClaw().State == 5005 then
		self.playerDied = 1
	end
	if GetClaw().State == 31 or ( GetClaw().Health > 1 and GetClaw().Health < 100 ) then
		self.playerGotHit = 1
		--TextOut("hit")
	end
	--TextOut(GetClaw().State)
	if self.bossStager.stage ~= nil then
		if self.bossStager.stage >= 53 and self.noDeath == 0 then
			self.noDeath = 1
			if self.playerDied == 0 then
				self.achievements_input[14] = 1
			end
		end
	end
	local TreasureScore = CalculateTreasureScore(PlayerData()._unkns[TreasureType.Skull - 1],
	PlayerData()._unkns[TreasureType.Crown - 1],PlayerData()._unkns[TreasureType.Gecko - 1],
	PlayerData()._unkns[TreasureType.Scepter - 1],PlayerData()._unkns[TreasureType.Cross - 1],
	PlayerData()._unkns[TreasureType.Chalice - 1],PlayerData()._unkns[TreasureType.Ring - 1],
	PlayerData()._unkns[TreasureType.Goldbar - 1],PlayerData()._unkns[TreasureType.Coin - 1])
	
	if self.bossStager.stage ~= nil then
		if self.bossStager.stage >= 0 and self.Flag1 == 0 then
			self.Flag1 = 1
			GetObject(7346):Destroy()
			if TreasureScore/self.maxTreasurePoints >= 0.95 then
				self.achievements_input[4] = 1
			end
			if TreasureScore/self.maxTreasurePoints <= 0.08 then
				self.achievements_input[16] = 1
			end
			if self.playerGotHit == 0 then
				self.achievements_input[17] = 1
			end
			if self.playerKill == 0 then
				self.achievements_input[18] = 1
			end
		end
	end
	if self.Flag2 == 0 and self.CaptainKills >= 13 then
		self.Flag2 = 1
		self.achievements_input[13] = 1
	end
	
	-- fpsy
	--TextOut(nRes(6))
	
	
	-- Cptns 81 598 1250 2392 3325 4450 4643 4990 5145 5537 6140 6176 6248 -- Confirm 13 kills of high officers before the boss battle
	--TextOut(self.CaptainKills)
	--TextOut(ffi.cast("int*", _nResult[0][18])[74])
end