function getTreasureTable(self)
	local AchievementsObject = GetObject(7250)
	return {PlayerData()._unkns[TreasureType.Skull - 1],
	PlayerData()._unkns[TreasureType.Crown - 1],PlayerData()._unkns[TreasureType.Gecko - 1],
	PlayerData()._unkns[TreasureType.Scepter - 1],PlayerData()._unkns[TreasureType.Cross - 1],
	PlayerData()._unkns[TreasureType.Chalice - 1],PlayerData()._unkns[TreasureType.Ring - 1],
	PlayerData()._unkns[TreasureType.Goldbar - 1],PlayerData()._unkns[TreasureType.Coin - 1],
	GetTime()+AchievementsObject.TimePenalty[1], PlayerData().Lives, PlayerData().PistolAmmo, PlayerData().TNTAmmo, PlayerData().MagicAmmo, GetClaw().Health, 
	AchievementsObject.playerDied, AchievementsObject.CaptainKills, AchievementsObject.playerGotHit, AchievementsObject.playerKill}
end

function ArrayToText(array)
	local str = ""
	str = str .. tostring(array[1])
	for i = 2, 19, 1 do
		str = str .. ";" .. tostring(array[i])
	end
	return str
end

function SaveToFile(self)
	self.file = io.open("Custom/Raid on the Spanish Armada/save.txt", "w")
	io.output(self.file)
	io.write(ArrayToText(self.TreasureTable[1]))
	io.write("\n")
	io.write(ArrayToText(self.TreasureTable[2]))
	io.close(self.file)
end

function main(self)
	
	if self.State == 0 then
		if GetGameType() ~= 3 then 
			self:Destroy()
			return 0
		end
		self.file = io.open("Custom/Raid on the Spanish Armada/save.txt", "r")
		-- { Skulls, Crowns, Geckos, Scepters, Crosses, Chalices, Rings, Klementynki, Coins, Time_played, Lives, Pistol, Dynamite, Magic, Health, Has_player_died, Captains_killed, got hit, killed }
		if self.file == nil then -- save file does not exist
			self.file = io.open("Custom/Raid on the Spanish Armada/save.txt", "w")
			io.output(self.file)
			io.write(ArrayToText{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0})
			io.write("\n")
			io.write(ArrayToText{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0})
			io.close(self.file)
			self.TreasureTable = {}
			self.TreasureTable[1] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
			self.TreasureTable[2] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
		else -- save file exists
			local textdump = self.file:read("*line")
			self.TreasureTable = {}
			self.TreasureTable[1] = {}
			local i = 1
			for token in string.gmatch(textdump, "[^;]+") do
				self.TreasureTable[1][i] = tonumber(token)
				i = i + 1
			end
			local textdump2 = self.file:read("*line")
			self.TreasureTable[2] = {}
			local i = 1
			--TextOut(textdump .. " " .. textdump2)
			for token in string.gmatch(textdump2, "[^;]+") do
				self.TreasureTable[2][i] = tonumber(token)
				i = i + 1
			end
			
			io.close(self.file)
		end
		self.FirstSaveFlag = GetObject(1967)
		self.FirstSaveFlagSaved = 0 
		self.SecondSaveFlag = GetObject(4460)
		self.SecondSaveFlagSaved = 0 
		
		
		if self.TreasureTable[1][10] ~= 0 then
			local l1 = CreateObject {x=864, y=4384, z=4000, name="SaveWarp", logic="CustomLogic", image="CUSTOM_SAVEWARP", SpeedX = 25955, SpeedY = 5339, Health = 1967, Damage = 1}
			l1.I = 1
			l1:SetFrame(1)
		end
		if self.TreasureTable[2][10] ~= 0 then
			local l2 = CreateObject {x=960, y=4384, z=4000, name="SaveWarp", logic="CustomLogic", image="CUSTOM_SAVEWARP", SpeedX = 51314, SpeedY = 5309, Health = 4460, Damage = 2}
			l2.I = 2
			l2:SetFrame(2)
		end
		--TextOut(self.TreasureTable[2])
		
		self.State = 1
	end
	
	if self.FirstSaveFlag.State == 6 and self.FirstSaveFlagSaved == 0 then
		if ffi.cast("int*", _nResult[0][18])[74] == 0 then
			TextOut("Your game has been saved")
			self.TreasureTable[1] = getTreasureTable(self)
			SaveToFile(self)
			self.FirstSaveFlagSaved = 1
		else
			TextOut("The game was not saved, because you cheated!")
			self.FirstSaveFlagSaved = 1
		end
	end
	if self.SecondSaveFlag.State == 6 and self.SecondSaveFlagSaved == 0 then
		if ffi.cast("int*", _nResult[0][18])[74] == 0 then
			TextOut("Your game has been saved")
			self.TreasureTable[2] = getTreasureTable(self)
			SaveToFile(self)
			self.SecondSaveFlagSaved = 1
		else
			TextOut("The game was not saved, because you cheated!")
			self.SecondSaveFlagSaved = 1
		end
	end
	
	
end